import es
import playerlib
import services


def load():
	global auth_service

	if not es.exists('clientcommand', '!respawn'):
		es.regclientcmd('!respawn', 'mani_respawn/respawn_consolecall', 'Requires the input of a player name on the server')
		
	#AUTH IS BASED ON MANI'S CLIENTS.TXT - SO MAKE SURE MANI_BASIC_AUTH IS LOADED
	#YOU MUST HAVE THIS LINE IN YOUR AUTOEXEC.CFG FOR AUTH TO WORK: es_load examples/auth/mani_basic_auth
	if services.isRegistered('auth'):
		auth_service = services.use('auth')
	else:
		auth_service = None

		
#prints the name of the person who called '!respawn' from the console, then respawns the target_id
def respawn_consolecall():
	userid = es.getcmduserid()
	if auth_service:
		if auth_service.isUseridAuthorized(userid, 'mani_flag_admin'):		
			target_name = es.getargs()
			target_id = es.getuserid(target_name) if target_name else 0
			if target_id:
				if (playerlib.getPlayer(target_id).isdead and playerlib.getPlayer(target_id).teamid > 1):
					es.msg('#green', 'Admin %s has respawned player %s' % (es.getplayername(userid), es.getplayername(target_id)))
					respawn(target_id)
				else:
					es.tell(userid, 'Player %s is not dead or is not on a valid team' % target_name)
			else:
				es.tell(userid, 'Player %s not found' % target_name)
		else:
			es.tell(userid, 'You are not authorized to respawn players')

def respawn(target):
	es.setplayerprop(target, "CCSPlayer.m_iPlayerState", 0)
	es.setplayerprop(target, "CCSPlayer.baseclass.m_lifeState", 512)
	es.spawnplayer(target)
	

def unload():
	es.unregclientcmd('!respawn')